package com.openeggbert.jdotnet.JDotNet.Properties;

/**
 * Represents a property that supports both read and write operations for a value of type T.
 *
 * The interface extends both IReadOnlyProperty and IWriteOnlyProperty, combining their
 * functionality to provide a complete property interface.
 *
 * @param <T> the type of the property's value
 */
public interface IProperty<T> extends IReadOnlyProperty<T>, IWriteOnlyProperty<T> {
}
